; main.s
; Desenvolvido para a placa EK-TM4C1294XL
; Exemplo de uso de GPIO ...
; Prof. Guilherme de S. Peron	- 12/03/2018
; Prof. Marcos E. P. Monteiro	- 12/03/2018
; Prof. DaLuz           		- 25/02/2022

;################################################################################

; Programa de Exemplo de uso da GPIO com interrupo utilizando o PM0 e PK7

;################################################################################
	THUMB											; Instrues do tipo Thumb-2
;################################################################################
; Definies dos Registradores Gerais.  Obs: *(EQU)=(EQUATE)*
;<NOME>	EQU	<VALOR>
;################################################################################
; rea de Dados - Declaraes de variveis
	AREA  DATA, ALIGN=2
	; Se alguma varivel for chamada em outro arquivo
	;EXPORT  <var> [DATA,SIZE=<tam>]	; Permite chamar a varivel <var> a 
		                                ; partir de outro arquivo
;<var>	SPACE <tam>                     ; Declara uma varivel de nome <var>
                                        ; de <tam> bytes a partir da primeira 
                                        ; posio da RAM		
;################################################################################
; rea de Cdigo - Tudo abaixo da diretiva a seguir ser armazenado na memria de 
;                  cdigo
	AREA    |.text|, CODE, READONLY, ALIGN=2
	; Se alguma funo do arquivo for chamada em outro arquivo	
    EXPORT Start                		; Permite chamar a funo Start a partir de 
										; outro arquivo. No caso startup.s
	; Se chamar alguma funo externa	
	;IMPORT <func>              		; Permite chamar dentro deste arquivo uma 
										; funo <func>
	IMPORT  PLL_Init
	IMPORT  SysTick_Init
	IMPORT  SysTick_Wait1ms			
	IMPORT  GPIO_Init
	IMPORT  PortN_Output
;################################################################################
; Funo main()
Start  		
	BL		PLL_Init                  	;Chama a subrotina para alterar o clock do microcontrolador para 80MHz
	BL		SysTick_Init              	;Chama a subrotina para inicializar o SysTick
	BL		GPIO_Init                 	;Chama a subrotina que inicializa os GPIO

MainLoop
	CMP		R10,#1						;Flag para sinalizar passagem pela interrupo
	BNE		AscendeLed					;Desvia para AscendeLed se setado o flag ...
ApagaLed
	MOV		R0,#0						;Parmetro de entrada da subrotina
	BL		PortN_Output				;Chama subrotina PortN_Output
	B		MainLoop					;Salta para MainLoop
AscendeLed
	MOV		R0,#1						;Parmetro de entrada da subrotina
	BL		PortN_Output				;Chama subrotina PortN_Output
	B		MainLoop					;Loop Programa Principal (MainLoop)


;################################################################################
; Fim do Arquivo
;################################################################################
    ALIGN                        		;Garante que o fim da seo est alinhada 
    END                          		;Fim do arquivo